<h1>Flexbox</h1>

<p>Flexbox is a responsive way to format elements inside a container, it is more efficient way to lay out, align and
  distribute elements.
  The main purpose of flexbox is so that elements can change in size and space dynamically in response to the available
  space or size of the browser window.</p>
<p>Flexbox is not a single property but a collection of properties. Some of those properties are applied to the <em>'flex-container'</em>
  (parent container),
  other properties are applied to the <em>'flex-items'</em> (elements inside the container).</p>

<em>Container</em>
<div class="container1">
  <div class="box blueBox">Item 1</div>
  <div class="box blueBox">Item 2</div>
  <div class="box blueBox">Item 3</div>
</div>

<div>
<br>
<h1>Flex Container</h1>
<p>To define a flex container we simple give it the <em>'display: flex'</em> property. This enables flex properties to
  be applied to its
  child items.</p>

<div class="col-md-4 codeExample">
  <em>styles.css</em>
  <pre>
  .container {{'{'}}
    display: flex;
  }
</pre>
</div>

<br>
<h3>Flex-Direction</h3>
<p><em>Flex-direction</em> allows you to specify which direction you want your items to be displayed; vertical or
  horizontal. By default items are displayed horizontally.
  You can give the flex-direction property the following values:</p>
<ul>
  <li><em>row:</em> This is the default and would produce the same as the example above.</li>
  <li><em>row-reverse:</em> This will display the items in a row backwards, so item 3 will be first and so on.</li>
  <li><em>column:</em> This will display the items in a column in ascending order.</li>
  <li><em>column-reverse:</em> This will display the items in a column but the last item at the top, in descending
    order.
  </li>
</ul>

<div class="col-md-4 codeExample">
  <em>styles.css</em>
  <pre>
  .container {{'{'}}
    display: flex;
    flex-direction: column-reverse;
  }
</pre>
</div>
<br>

<div class="container2">
  <div class="box blueBox">1</div>
  <div class="box blueBox">2</div>
  <div class="box blueBox">3</div>
</div>

<br>
<h3>Flex-wrap</h3>
<p>The <em>flex-wrap</em> property allows you to specify whether items in a container can start a new line if the window
  gets smaller. By default it will try to
  fit all the elements on one line. The flex-wrap property can have the following values:</p>
<ul>
  <li><em>nowrap:</em> This is the default, all items will be displayed one line, even if it means the items are made
    smaller.
  </li>
  <li><em>wrap:</em> This retains the items width and height, and moves the items to the next line if the window becomes
    to small.
  </li>
  <li><em>wrap-reverse: </em>Items are displayed on multi lines however the original bottom line is displayed first and
    it works backwards.
  </li>
</ul>

<div class="col-md-4 codeExample">
  <em>styles.css</em>
  <pre>
  .container {{'{'}}
    display: flex;
    flex-direction: row;
    flex-wrap: wrap
  }
</pre>
</div>
<br>

<em>Try resizing the window</em>
<div class="container3">
  <div class="box blueBox">1</div>
  <div class="box blueBox">2</div>
  <div class="box blueBox">3</div>
  <div class="box blueBox">4</div>
  <div class="box blueBox">5</div>
  <div class="box blueBox">6</div>
  <div class="box blueBox">7</div>
  <div class="box blueBox">8</div>
  <div class="box blueBox">9</div>
  <div class="box blueBox">10</div>
</div>

<br>
<h3>Flex-flow</h3>
<p>The <em>flex-flow</em> property is a shorthand that allows you to define the <em>flex-direction</em> and <em>flex-wrap</em>
  on one line.</p>
<div class="col-md-4 codeExample">
  <em>styles.css</em>
  <pre>
  .container {{'{'}}
    display: flex;
    flex-flow: row wrap;
  }
</pre>
</div>
<br>

<h3>Justify-content</h3>
<p>The <em>justify-content</em> property allows you to define how the spacing between the items is distributed. The
  justify-content property can have the following values:</p>


<div class="container4">
  <div class="box blueBox">1</div>
  <div class="box blueBox">2</div>
  <div class="box blueBox">3</div>
  <div class="box blueBox">4</div>
  <div class="box blueBox">5</div>
</div>
<p><em>Flex-start:</em> Items are displayed at the beginning of the container.</p>
<br>
<div class="container5">
  <div class="box blueBox">1</div>
  <div class="box blueBox">2</div>
  <div class="box blueBox">3</div>
  <div class="box blueBox">4</div>
  <div class="box blueBox">5</div>
</div>
<p><em>Flex-end:</em> Items are displayed at the end of the container.</p>
<br>

<div class="container6">
  <div class="box blueBox">1</div>
  <div class="box blueBox">2</div>
  <div class="box blueBox">3</div>
  <div class="box blueBox">4</div>
  <div class="box blueBox">5</div>
</div>
<p><em>Flex-center:</em> Items are displayed in the center of the container.</p>
<br>
<div class="container7">
  <div class="box blueBox">1</div>
  <div class="box blueBox">2</div>
  <div class="box blueBox">3</div>
  <div class="box blueBox">4</div>
  <div class="box blueBox">5</div>
</div>
<p><em>Space-between</em>: The first item to start at the beginning of the container, the last item at the end of the
  container and the rest of the items are spaced evenly in between.</p>
<br>
<div class="container8">
  <div class="box blueBox">1</div>
  <div class="box blueBox">2</div>
  <div class="box blueBox">3</div>
  <div class="box blueBox">4</div>
  <div class="box blueBox">5</div>
</div>
<p><em>Space-evenly</em>: Spaces between the items and the edge of the container is equal</p>
<br>
<div class="container9">
  <div class="box blueBox">1</div>
  <div class="box blueBox">2</div>
  <div class="box blueBox">3</div>
  <div class="box blueBox">4</div>
  <div class="box blueBox">5</div>
</div>
<p><em>Space-around</em>: This is similar to space-evenly, the difference is that the edge items have 1 space from the container but 2 spaces between them and the next item.</p>

<div class="col-md-4 codeExample">
  <em>styles.css</em>
  <pre>
  .container {{'{'}}
    display: flex;
    justify-content: space-evenly;
  }
</pre>
</div>
<br>

<h3>Align Items</h3>
<p>The <em>align-items</em> property is used to align items vertically in its container. Here are the values you can give this property:</p>
<ul>
  <li><em>flex-start:</em>  Items are aligned to the top of the container.</li>
  <li><em>flex-end:</em> Items are aligned to the bottom on the container.</li>
  <li><em>center:</em> Items are centered vertically of the container.</li>
  <li><em>stretch:</em> This is the default, if items do not have a specified height, then the container will stretch them from top to bottom of container. </li>
  <li><em>baseline:</em> Items are aligned by their content baseline. For example if each item has text, it is aligned by the baseline of the text.</li>
</ul>



<em>flex-end</em>
<div class="container10">
  <div class="box blueBox">1</div>
  <div class="box blueBox">2</div>
  <div class="box blueBox">3</div>
  <div class="box blueBox">4</div>
  <div class="box blueBox">5</div>
</div>
<br>
<div class="col-md-4 codeExample">
  <em>styles.css</em>
  <pre>
  .container {{'{'}}
    display: flex;
    align-items: flex-end;
    height: 200px;
    width: 600px;
  }
</pre>
</div>
<br>

<h3>Align Content</h3>
<p><em>Align-contnet</em> is similar to justify content except it looks at how space is distributed vertically. The values you can give the align-content property
are the following: </p>
<ul>
  <li><em>flex-start:</em>  Items are aligned to the start of the container.</li>
  <li><em>flex-end:</em> Items are aligned to the end on the container.</li>
  <li><em>center:</em> Items are centered vertically of the container.</li>
  <li><em>stretch:</em> This is the default, items are stretched to take up available space. </li>
  <li><em>space-between:</em> Items are displayed with equal vertical space between the rows.</li>
  <li><em>space-around:</em> Items have equal vertical space before and after them.</li>
  <li><em>space-evenly:</em> Items are displayed with equal vertical space between the edge of the container and other items.</li>
</ul>

</div>

<br>

<div>
  <h1>Flex Items</h1>
  <p>So far we have been looking at properties we can apply to the container, in this section we will look at properties we can
  directly apply to flex items. </p>
  <h3>Order</h3>
  <p>The <em>order</em> property allows you to define the order you want the items to be displayed. The default value is 0, meaning items will be displayed in the order they have been
  written in the HTML. The value can be a negative or positive number. The lowest value is displayed first, the highest displayed last.</p>

  <p>Notice the code below, we have set the order of items to go 2, 3, 1.</p>
  <div class="col-md-4 codeExample">
    <em>styles.css</em>
  <pre>
  .item1 {{'{'}}
    order: 3;
  }
  .item2 {{'{'}}
    order: 1;
  }
  .item3 {{'{'}}
    order: 2;
  }
  </pre>
  </div>
  <br>

  <div class="container1">
    <div class="box blueBox item1">1</div>
    <div class="box blueBox item2">2</div>
    <div class="box blueBox item3">3</div>
  </div>

<br>
<h3>Flex-Grow</h3>
<p>The <em>flex-grow</em> property specifies which items can grow when the browser window is extended and how fast they can grow.
For example if you want one item to be able to grow more than others then you can give it priority. The default value is 0 meaning that
each item grows equally. The higher the value the higher the priority. Changing the flex-grow property will ignore any width you may have given the items.</p>

  <p>In the example below we have given item 3 the value 8 which tells the browser that we want it to grow 8 times faster that the other two items.</p>

  <div class="col-md-4 codeExample">
    <em>styles.css</em>
    <pre>
  .item4 {{'{'}}
    flex-grow: 1;
  }
  .item5 {{'{'}}
    flex-grow: 1;
  }
  .item6 {{'{'}}
    flex-grow: 8;
  }
  </pre>
  </div>
  <br>

<em>Stretch and squeeze the window to see the items grow. </em>
  <div class="container12">
    <div class="box blueBox item4">1</div>
    <div class="box blueBox item5">2</div>
    <div class="box blueBox item6">3</div>
  </div>

  <br>
<h3>Flex-Shrink</h3>
<p>The <em>flex-shrink</em> property defines which items should shrink more than others, also lets you prevent items from shrinking if window is made smaller.
The default value is 1, which means all items shrink equally. Negative values are not valid, Value of 2 means that item should shrink more quicker then others. The 0 value
specifies that an item cannot shrink and must retain its original size. </p>

  <p>In the example below, we are making sure item 4 does not shrink and item 7 to shrink quicker than other items. </p>

  <div class="col-md-4 codeExample">
    <em>styles.css</em>
    <pre>
  .item4 {{'{'}}
    flex-shrink: 0;
  }
  .item7 {{'{'}}
    flex-shrink: 2;
  }
  </pre>
  </div>
  <br>

  <em>Make the window smaller to see the effect on item 4 and 7</em>
  <div class="container12">
    <div class="box2 blueBox">1</div>
    <div class="box2 blueBox">2</div>
    <div class="box2 blueBox">3</div>
    <div class="box2 blueBox item8">4</div>
    <div class="box2 blueBox">5</div>
    <div class="box2 blueBox">6</div>
    <div class="box2 blueBox item7">7</div>
    <div class="box2 blueBox">8</div>
    <div class="box2 blueBox">9</div>
    <div class="box2 blueBox">10</div>
  </div>

  <br>
  <h3>Flex-Basis</h3>
  <p><em>Flex-basis</em> property allows to specify the default length of an individual flex item. The example below sets item 2 to 400px by default.  </p>

  <div class="col-md-4 codeExample">
    <em>styles.css</em>
    <pre>
  .item2 {{'{'}}
    flex-basis: 400px;
  }
  </pre>
  </div>
  <br>
  <div class="container12">
    <div class="box2 blueBox">1</div>
    <div class="box2 blueBox item9">2</div>
    <div class="box2 blueBox">3</div>
    <div class="box2 blueBox">4</div>
    <div class="box2 blueBox">5</div>
    <div class="box2 blueBox">6</div>
    <div class="box2 blueBox">7</div>
    <div class="box2 blueBox">8</div>
    <div class="box2 blueBox">9</div>
    <div class="box2 blueBox">10</div>
  </div>

  <br>
<h3>Flex Property</h3>
<p>The <em>flex</em> property is a shorthand that lets you define the <em>flex-grow</em>, <em>flex-shrink</em> and <em>flex-basis</em>
property on one line. The example below states that item 3 can grow equally (0), cannot shrink(0) and is default size of 200px.</p>

  <div class="col-md-4 codeExample">
    <em>styles.css</em>
    <pre>
  .item3 {{'{'}}
    flex: 0, 0, 200px;
  }
  </pre>
  </div>
  <br>

  <h3>Self-align</h3>
  <p>This property lets you set an alignment of individual items. This will override the align property you may have set on the container.</p>
  <div class="col-md-4 codeExample">
    <em>styles.css</em>
    <pre>
  .item2 {{'{'}}
    self-align: flex-start;
  }
  .item3 {{'{'}}
    self-align: flex-end;
  }
  </pre>
  </div>
  <br>

  <div class="container13">
    <div class="box3 blueBox">1</div>
    <div class="box3 blueBox item10">2</div>
    <div class="box3 blueBox item11">3</div>
    <div class="box3 blueBox">4</div>
  </div>

</div>





